Index: tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java
===================================================================
--- tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 773)
+++ tmp/org.txm.progression.rcp/src/org/txm/progression/rcp/editors/ProgressionEditor.java	(revision 774)
@@ -29,6 +29,7 @@
 import org.txm.chartsengine.r.core.themes.DefaultTheme;
 import org.txm.chartsengine.rcp.editors.ChartEditor;
 import org.txm.core.results.Parameter;
+import org.txm.core.results.TXMResult;
 import org.txm.progression.core.functions.Progression;
 import org.txm.progression.core.preferences.ProgressionPreferences;
 import org.txm.progression.rcp.messages.ProgressionUIMessages;
@@ -97,7 +98,7 @@
 	 * Queries.
 	 */
 	@Parameter(key=ProgressionPreferences.QUERIES)
-	protected List<Query> queries;
+	protected List<Query> queryList;
 
 	/**
 	 * Structural unit.
@@ -195,8 +196,9 @@
 				@Override
 				public void keyPressed(KeyEvent e) {
 					if (e.keyCode == SWT.CR || e.keyCode == SWT.KEYPAD_CR) {
-						onPlusButtonPressed(null, queryWidget.getQueryString());
-						super.keyPressed(e);
+						if (onPlusButtonPressed(null, queryWidget.getRawString())) {
+							super.keyPressed(e); // recompute only if the query has been added
+						}
 					}
 				}
 			});
@@ -331,15 +333,21 @@
 					String path = dialog.open();
 					if (path != null) {
 						Properties props = new Properties();
+						int count = 0;
 						try {
 							props.load(IOUtils.getReader(new File(path)));
 							for (Object k : props.keySet()) {
-								onPlusButtonPressed(event, props.get(k).toString());
+								if (onPlusButtonPressed(event, props.get(k).toString())) {
+									count++;
+								}
 							}
 						} catch (Exception e) {
 							// TODO Auto-generated catch block
 							e.printStackTrace();
 						}
+						if (count > 0) {
+							compute(true);
+						}
 					}
 				}
 			});
@@ -347,19 +355,21 @@
 		} catch (Exception e) {
 			Log.printStackTrace(e);
 		}
-
-
 	}
 
-	public void onPlusButtonPressed(Event event, String defaultValue) {
+	public boolean onPlusButtonPressed(Event event, String defaultValue) {
 		if (colors.length > queryWidgets.size()) {
 			Log.info("add query field");
-			QueryField qf = addFocusQueryField();
-			if (qf != null) qf.setQuery(defaultValue);
+			
+			QueryField qf = addFocusQueryField(defaultValue);
 			sc1.layout(true);
 			queriesFocusComposite.layout(true);
 			sc1.setMinSize(queriesFocusComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
+			
+			return qf != null;
 		}
+		
+		return false;
 	}
 
 
@@ -372,7 +382,7 @@
 
 		protected AssistedQueryWidget focusTextBox;
 
-		protected TXMEditor editor;
+		protected TXMEditor<? extends TXMResult> editor;
 
 		/**
 		 * 
@@ -428,6 +438,10 @@
 		public void memorize() {
 			focusTextBox.memorize();
 		}
+
+		public String getRawString() {
+			return focusTextBox.getRawString();
+		}
 	}
 
 	/**
@@ -440,8 +454,8 @@
 		// do not add same query twice
 		if (initialQuery != null && initialQuery.length() > 0) { // test only if the initial query is set
 			for (int i = 0; i < queryWidgets.size(); i++) {
-
-				if (queryWidgets.get(i).getQuery().getQueryString().equals(initialQuery))	{
+				String existing = queryWidgets.get(i).getRawString();
+				if (existing.equals(initialQuery))	{
 					System.out.println("The query already exists: " + initialQuery);
 					return null;
 				}
@@ -473,11 +487,11 @@
 	public void updateEditorFromChart(boolean update) {
 
 		// create the queries fields
-		if (queries == null) {
-			//addFocusQueryField();
-		}
-		else {
-			for (Query q : queries) {
+//		if (queryList == null) {
+//			//addFocusQueryField();
+//		}
+		if (queryWidgets.size() == 0 && queryList != null) { // initialize query fields
+			for (Query q : queryList) {
 				addFocusQueryField(q.getQueryString()); 
 			}
 		}
@@ -493,10 +507,10 @@
 	@Override
 	public void updateResultFromEditor() {
 
-		queries = new ArrayList<Query>();
+		queryList = new ArrayList<Query>();
 		for (QueryField wid : queryWidgets) {
 			if (!wid.getQuery().isEmpty()) { //$NON-NLS-1$
-				queries.add(wid.getQuery());
+				queryList.add(wid.getQuery());
 				wid.memorize();
 			}
 		}
Index: tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedQueryWidget.java
===================================================================
--- tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedQueryWidget.java	(revision 773)
+++ tmp/org.txm.rcp/src/main/java/org/txm/rcp/swt/widget/AssistedQueryWidget.java	(revision 774)
@@ -110,6 +110,15 @@
 	public String getQueryString() {
 		return querywidget.getQueryString();
 	}
+	
+	/**
+	 * Gets the query string.
+	 *
+	 * @return the query string
+	 */
+	public String getRawString() {
+		return querywidget.getText();
+	}
 
 	/**
 	 * Memorize.
